import math

def hit(sprite, x, y):
    return (x >= sprite.x and x < sprite.x + sprite.width and
            y >= sprite.y and y < sprite.y + sprite.height)

def hit_opaque(sprite, x, y):
    return (hit(sprite, x, y) and ord(sprite.image.get_image_data().
            get_data('A', sprite.width)[x - sprite.x + sprite.width *
                                        (y - sprite.y)]) > 0)

def hit_sprite(sprite1, sprite2):
    return (not (sprite1.x > sprite2.x + sprite2.width or
                 sprite1.x + sprite1.width < sprite2.x or
                 sprite1.y + sprite1.height < sprite2.y or
                 sprite1.y > sprite2.y + sprite2.height))

def hit_rect_sprite(left, right, top, bottom, sprite2):
    return (not (left > sprite2.x + sprite2.width or
                 right < sprite2.x or
                 top < sprite2.y or
                 bottom > sprite2.y + sprite2.height))
